'use strict';

var createEvents = require('./create-events');
var registerEvents = require('./register-events');

function createMetaReducer(eventDefinitionsMap, target) {
  var extensions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  /* eslint-disable func-names */
  return function (reducer) {
    return function (prevState, action) {
      if (!eventDefinitionsMap[action.type]) {
        return reducer(prevState, action);
      }

      var events = createEvents(eventDefinitionsMap[action.type], prevState, action);
      registerEvents(events, target, extensions, prevState, action);

      return reducer(prevState, action);
    };
  };
}

module.exports = createMetaReducer;