'use strict';

var createEvents = require('./create-events');
var registerEvents = require('./register-events');

function createMiddleware(eventDefinitionsMap, target) {
  var extensions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  return function (store) {
    return function (next) {
      return function (action) {
        if (!eventDefinitionsMap[action.type]) {
          return next(action);
        }

        var prevState = store.getState();

        var events = createEvents(eventDefinitionsMap[action.type], prevState, action);

        registerEvents(events, target, extensions, prevState, action);

        return next(action);
      };
    };
  };
}

module.exports = createMiddleware;